#!/bin/bash

###
###
### Really if you are nothing and you don't want to install a package :)
### Work with bash (not sh).
###
###

entry_hide()
{
    # $1 -> title
    # $2 -> text
    # $3 -> default entry

    HIDDING=1
    entry_text_widget "$1" "$2" "$3"
    RET_VAL=$?
    HIDDING=""
    return $RET_VAL
}

entry_text()
{
    # $1 -> title
    # $2 -> text
    # $3 -> default entry

    HIDDING=""
    entry_text_widget "$1" "$2" "$3"
    return $?
}

entry_arrow_left()
{
    entry_offset_x=$(($entry_offset_x - 1))
    [ "$entry_offset_x" -lt "0" ] && entry_offset_x=0 && return
    tput cup 5 $(($entry_x + $entry_offset_x)) >&2
}

entry_arrow_right()
{
    [ "$(($entry_offset_x))" -eq "$entry_nb_letters" ] && return
    [ -z "$HIDDING" ] && echo -n "${stockage_val[$entry_offset_x]}" >&2 || echo -n "*" >&2
    entry_offset_x=$(($entry_offset_x + 1))
}

entry_insert_val()
{
    [ "$(($entry_nb_letters + 1))" -eq "30" ] && return 
    [ -z "$HIDDING" ] && echo -n "$1" >&2 || echo -n "*" >&2
     
    tmp="$((entry_nb_letters - 1))"
    tmp_aff=""
    while [ "$tmp" -ge "$entry_offset_x" ] ; do
	stockage_val[$(($tmp + 1))]="${stockage_val[$tmp]}"
	[ -z "$HIDDING" ] && tmp_aff="${stockage_val[$tmp]}$tmp_aff" || tmp_aff="*$tmp_aff"
	tmp=$(($tmp - 1))
    done
    if [ -n "$tmp_aff" ] ; then
	echo -n "$tmp_aff" >&2
	tput cup 5 $(($entry_x + $entry_offset_x + 1)) >&2
    fi

    stockage_val[$entry_offset_x]="$1"
    entry_offset_x=$(($entry_offset_x + 1))
    entry_nb_letters=$(($entry_nb_letters + 1))
}

entry_delete_val()
{
    [ "$entry_offset_x" -eq 0 ] && return 0
    tmp=$entry_offset_x
    tmp_aff=""
    while [ "$tmp" -lt "$entry_nb_letters" ] ; do
	[ -z "$HIDDING" ] && tmp_aff="$tmp_aff${stockage_val[$tmp]}" || tmp_aff="${tmp_aff}*"
	stockage_val[$(($tmp - 1))]="${stockage_val[$tmp]}"
	tmp=$(($tmp + 1))
    done
    entry_arrow_left
    echo -n "$tmp_aff " >&2    
    tput cup 5 $(($entry_x + $entry_offset_x)) >&2
    entry_nb_letters=$(($entry_nb_letters - 1))
    return 0
}

key_tabulation_entry()
{
    position=$(($position + 1))
    [ "$position" -gt "2" ] && position="0"
    if [ "$position" -eq "0" ] ; then 
	aff_cancel_button 0
	tput cup 5 $(($entry_x + $entry_offset_x)) >&2
    fi
    if [ "$position" -eq "1" ] ; then 
	aff_ok_button 1
    fi
    if [ "$position" -eq "2" ] ; then 
	aff_ok_button 0
	aff_cancel_button 1
    fi
    return 0
}

entry_text_widget()
{
    # $1 -> title
    # $2 -> text
    # $3 -> default entry

    tput clear >&2
    stty -echo
    nb_term_cols=$(tput cols)
    nb_lines=$(tput lines)
    tput cup 0 $(($nb_term_cols / 2 - ${#1} / 2)) >&2
    tput bold >&2
    echo "$1" >&2
    tput sgr0 >&2
    echo "" >&2
    echo "" >&2
    echo "               $2" >&2
    entry_x=$(($nb_term_cols / 2 - ${#1} / 2 - 10 + 7))
    tput cup 5 $(($entry_x - 7)) >&2
    echo "Entry: " >&2
    IFS=$SAVE_IFS
    IFS=""
    nb_champ=4
    position=0
    entry_nb_letters=0
    entry_offset_x=0
    
    aff_ok_button 0
    aff_cancel_button 0
    
    tput cup 5 $entry_x >&2
    if [ -n "$3" ] && [ -z "$HIDDING" ] ; then
	echo -n "$3" >&2
	entry_offset_x=${#3}
	entry_nb_letters=$entry_offset_x
	tmp=0
	while [ "$tmp" -ne "$entry_nb_letters" ] ; do
	    stockage_val[$tmp]=$(echo "$3" | awk "{ split(\$0, tab,\"\"); printf(\"%s\", tab[$tmp + 1])}")
	    tmp=$(($tmp + 1))
	done
    fi
    while : ; do
	read -n 1 touche
	if [ "$touche" = "" ] ; then
	    read -n 1 touche
	    if [ "$touche" = "[" ] ; then
		read -n 1 touche
		if [ "$touche" = "D" ] ; then
		    entry_arrow_left
		fi
		if [ "$touche" = "C" ] ; then
		    entry_arrow_right
		fi
	    fi
	    continue
	fi
	[ "$touche" =  "	" ] && key_tabulation_entry && continue
	[ "$touche" = "" ] && entry_delete_val && continue
	if [ -z "$touche" ] ; then
	    [ "$position" -ne "0" ] && break
	    continue
	fi
	entry_insert_val "$touche"
    done

    stty echo
    tput sgr0 >&2
    IFS=$SAVE_IFS
    [ "$position" -eq "2" ] && return 1
    tmp=0
    tmp_aff=""
    while [ "$tmp" -ne "$entry_nb_letters" ] ; do
	tmp_aff="$tmp_aff${stockage_val[$tmp]}"
	tmp=$(($tmp + 1))
    done
    echo "$tmp_aff"
    return 0
}

info_text()
{
    # $1 -> title
    # $2 -> text

    echo "############## $1 ################"
    echo ""
    echo "$2"
    echo ""
 
    echo "Continue..."
    read -n 1 touche
    return 0
}

arrow_up()
{
    pos_depart=$(($pos_depart - 1))
    [ "$pos_depart" -lt "1" ] && pos_depart="$nb_champ"
    tput cup $((3 + $pos_depart)) $(($nb_term_cols / 2 - 13 + 1)) >&2
}

arrow_down()
{
    pos_depart=$(($pos_depart + 1))
    [ "$pos_depart" -gt "$nb_champ" ] && pos_depart="1"
    tput cup $((3 + $pos_depart)) $(($nb_term_cols / 2 - 13 + 1)) >&2
}

key_tabulation()
{
    position=$(($position + 1))
    [ "$position" -gt "2" ] && position="0"
    if [ "$position" -eq "0" ] ; then 
	aff_cancel_button 0
	tput cup $((3 + $pos_depart)) $(($nb_term_cols / 2 - 13 + 1)) >&2
    fi
    if [ "$position" -eq "1" ] ; then 
	aff_ok_button 1
    fi
    if [ "$position" -eq "2" ] ; then 
	aff_ok_button 0
	aff_cancel_button 1
    fi
}

aff_ok_button()
{
    [ "$1" -eq "1" ] && tput setaf 5 >&2
    tput cup $((5 + $nb_champ)) $(($nb_term_cols / 2 - 16)) >&2
    echo -n "--------" >&2
    tput cup $((5 + $nb_champ + 1)) $(($nb_term_cols / 2 - 16)) >&2
    echo -n "|  OK  |" >&2
    tput cup $((5 + $nb_champ + 2)) $(($nb_term_cols / 2 - 16)) >&2
    echo -n "--------" >&2
    [ "$1" -eq "1" ] && tput sgr0 >&2
}

aff_cancel_button()
{
    [ "$1" -eq "1" ] && tput setaf 5 >&2
    tput cup $((5 + $nb_champ)) $(($nb_term_cols / 2 + 5)) >&2
    echo -n "------------" >&2
    tput cup $((5 + $nb_champ + 1)) $(($nb_term_cols / 2 + 5)) >&2
    echo -n "|  CANCEL  |" >&2
    tput cup $((5 + $nb_champ + 2)) $(($nb_term_cols / 2 + 5)) >&2
    echo -n "------------" >&2
    [ "$1" -eq "1" ] && tput sgr0 >&2
}

set_radiolist()
{
    if [ -n "$pos_radio" ] ; then
	tput cup $((3 + $pos_radio)) $(($nb_term_cols / 2 - 13 + 1)) >&2
	echo -n " " >&2
    fi
    pos_radio="$pos_depart"
    tput cup $((3 + $pos_radio)) $(($nb_term_cols / 2 - 13 + 1)) >&2
    echo -n "*" >&2
    tput cup $((3 + $pos_radio)) $(($nb_term_cols / 2 - 13 + 1)) >&2
}

set_checklist()
{
    tmp=$(($pos_depart - 1))
    if [ -z "${check_list_values[$pos_depart]}" ] ; then
	echo -n "x" >&2
	tput cup $((3 + $pos_depart)) $(($nb_term_cols / 2 - 13 + 1)) >&2
	check_list_values[$pos_depart]="${stockage_val[$tmp]}"
    else
	echo -n " " >&2
	tput cup $((3 + $pos_depart)) $(($nb_term_cols / 2 - 13 + 1)) >&2
	check_list_values[$pos_depart]=""
    fi
}

radiolist_select()
{
    # $1 title
    # $2 text
    # $3 values. Must recreate data
    # $4 force height
    # $5 force width

    var="" 
    SAVE_IFS=$IFS
    IFS="
"
    tput clear >&2
    stty -echo
    nb_term_cols=$(tput cols)
    nb_lines=$(tput lines)
    pos_depart="1"
    nb_champ="0"
    position="0"
    pos_radio=""
    stockage_val=""
    tput cup 0 $(($nb_term_cols / 2 - ${#1} / 2)) >&2
    tput bold >&2
    echo "$1" >&2
    tput sgr0 >&2
    echo "" >&2
    echo "               $2:" >&2
    echo "" >&2
    for line in $3 ; do
	value=$(echo "$line" | awk -F \" 'BEGIN {var=""} { var=$2} END {print var }')
	tput cup $(($nb_champ + 1 + 3)) $(($nb_term_cols / 2 - 13)) >&2
	echo -n "( )  " >&2
	echo "$value" >&2
	stockage_val[$nb_champ]="$value"
	nb_champ=$(($nb_champ + 1))
    done
    IFS=$SAVE_IFS
    IFS=""
    aff_ok_button 0
    aff_cancel_button 0
    tput cup $((3 + $pos_depart)) $(($nb_term_cols / 2 - 13 + 1)) >&2
    while : ; do
	read -n 1 touche
	if [ "$touche" = "" ] ; then
	    read -n 1 touche
	    if [ "$touche" = "[" ] ; then
		read -n 1 touche
		if [ "$touche" = "A" ] ; then
		    arrow_up
		fi
		if [ "$touche" = "B" ] ; then
		    arrow_down
		fi
	    fi
	fi
	[ "$touche" =  "	" ] && key_tabulation
	[ "$touche" =  " " ] && [ "$position" -eq "0" ] && set_radiolist
	[ -z "$touche" ] && [ "$position" -ne "0" ] && break
    done
    stty echo
    tput sgr0 >&2
    IFS=$SAVE_IFS
    [ "$position" -eq "2" ] && return 1
    if [ -n "$pos_radio" ] ; then
	pos_radio=$(($pos_radio - 1))
	echo "${stockage_val[$pos_radio]}"
    fi
    return 0
}

checklist_select()
{
    # $1 title
    # $2 text
    # $3 values

    var="" 
    SAVE_IFS=$IFS
    IFS="
"
    tput clear >&2
    stty -echo
    nb_term_cols=$(tput cols)
    nb_lines=$(tput lines)
    pos_depart="1"
    nb_champ="0"
    position="0"
    stockage_val=""
    tput cup 0 $(($nb_term_cols / 2 - ${#1} / 2)) >&2
    tput bold >&2
    echo "$1" >&2
    tput sgr0 >&2
    echo "" >&2
    echo "               $2:" >&2
    echo "" >&2
    for line in $3 ; do
	value=$(echo "$line" | awk -F \" 'BEGIN {var=""} { if ($2) var=$2; else { split($1, tab," "); var=tab[2]}} END {print var }')
	true_false=$(echo "$line" | awk  '{ print $1 }')
	tput cup $(($nb_champ + 1 + 3)) $(($nb_term_cols / 2 - 13)) >&2
	stockage_val[$nb_champ]="$value"
	nb_champ=$(($nb_champ + 1))
	if [ "$true_false" = "TRUE" ] ; then  
	    echo -n "[x]  " >&2
	    check_list_values[$nb_champ]="$value"
	else
	    echo -n "[ ]  " >&2
	fi
	echo "$value" >&2

    done
    IFS=$SAVE_IFS
    IFS=""
    aff_ok_button 0
    aff_cancel_button 0
    tput cup $((3 + $pos_depart)) $(($nb_term_cols / 2 - 13 + 1)) >&2
    while : ; do
	read -n 1 touche
	if [ "$touche" = "" ] ; then
	    read -n 1 touche
	    if [ "$touche" = "[" ] ; then
		read -n 1 touche
		if [ "$touche" = "A" ] ; then
		    arrow_up
		fi
		if [ "$touche" = "B" ] ; then
		    arrow_down
		fi
	    fi
	fi
	[ "$touche" =  "	" ] && key_tabulation
	[ "$touche" =  " " ] && [ "$position" -eq "0" ] && set_checklist
	[ -z "$touche" ] && [ "$position" -ne "0" ] && break
    done
    stty echo
    tput sgr0 >&2
    IFS=$SAVE_IFS
    [ "$position" -eq "2" ] && return 1
    tmp=0
    aff=""
    while [ "$tmp" -lt "$nb_champ" ] ; do
	tmp_val=$(($tmp + 1))
	if [ -n "${check_list_values[$tmp_val]}" ] ; then
	    [ -n "$aff" ] && aff="$aff|${check_list_values[$tmp_val]}" || aff="${check_list_values[$tmp_val]}"
	fi
	check_list_values[$tmp_val]=""
	tmp=$(($tmp + 1))
    done
    echo "$aff"
    return 0
}

key_tabulation_question()
{
    position=$(($position + 1))
    [ "$position" -gt "1" ] && position="0"
    if [ "$position" -eq "0" ] ; then 
	aff_ok_button 1
	aff_cancel_button 0
    fi
    if [ "$position" -eq "1" ] ; then 
	aff_ok_button 0
	aff_cancel_button 1
    fi
}

question_select()
{
    # $1 title
    # $2 value

    tput clear >&2
    stty -echo
    nb_term_cols=$(tput cols)
    nb_lines=$(tput lines)
    tput cup 0 $(($nb_term_cols / 2 - ${#1} / 2)) >&2
    tput bold >&2
    echo "$1" >&2
    tput sgr0 >&2
    echo "" >&2
    echo "" >&2
    echo "               $2" >&2
    echo "" >&2    
    IFS=$SAVE_IFS
    IFS=""
    nb_champ=2
    position=0
    aff_ok_button 1
    aff_cancel_button 0
    
    while : ; do
	read -n 1 touche
	[ "$touche" =  "	" ] && key_tabulation_question
	[ -z "$touche" ] && break
    done

    stty echo
    tput sgr0 >&2
    IFS=$SAVE_IFS
    echo "$position"
    return 0
}


######################################################################

create_box()
{
    # $1: pos X
    # $2: pos Y
    # $3: width
    # $4: height

    BUFF_AFF="${BUFF_AFF}`tput cup $2 $1`"
    tmp=0
    while [ "$tmp" -lt "$3" ] ; do
	BUFF_AFF="${BUFF_AFF}-"
	tmp=$(($tmp + 1))
    done
    tmp_dst=$(($4 - 2))
    tmp=0
    while [ "$tmp" -lt "$tmp_dst" ] ; do
	BUFF_AFF="${BUFF_AFF}`tput cup $(($2 + $tmp + 1)) $1`"
	BUFF_AFF="${BUFF_AFF}|"
	tmp=$(($tmp + 1))
    done
    BUFF_AFF="${BUFF_AFF}`tput cup $(($2 + $4 - 1)) $1`"
    tmp=0
    while [ "$tmp" -lt "$3" ] ; do
	BUFF_AFF="${BUFF_AFF}-"
	tmp=$(($tmp + 1))
    done
    tmp_dst=$(($4 - 2))
    tmp=0
    while [ "$tmp" -lt "$tmp_dst" ] ; do
	BUFF_AFF="${BUFF_AFF}`tput cup $(($2 + $tmp + 1)) $(($1 + $3 - 1))`"
	BUFF_AFF="${BUFF_AFF}|"
	tmp=$(($tmp + 1))
    done
}

aff_fondation()
{
    width_zone=$(($nb_term_cols / 2 - 2))
    height_zone=$(($nb_lines - 5 - 4 - 3))
    BUFF_AFF=""
    create_box 1 5 $width_zone 3
    create_box 1 $((5 + 2)) $width_zone $height_zone

    create_box $((1 + $width_zone + 2)) 5 $width_zone 3
    create_box $((1 + $width_zone + 2)) $((5 + 2)) $width_zone $height_zone
    
    BUFF_AFF="${BUFF_AFF}`tput cup 6 3``tput bold`Directory`tput sgr0`"
    BUFF_AFF="${BUFF_AFF}`tput cup 6 $((1 + $width_zone + 2 + 2))``tput bold`Files`tput sgr0`"
    echo -n "$BUFF_AFF" >&2
    x_directory=2
    x_files=$((1 + $width_zone + 2 + 1))
    y_directory=8
    y_files=8
    tmp_zone_space=""
    tmp_val=2
    while [ "$tmp_val" -lt "$width_zone" ] ; do
	tmp_zone_space="${tmp_zone_space} "
	tmp_val=$(($tmp_val + 1))
    done
}

aff_dirs()
{
    tmp=0
    tmp_poss=$(($height_zone - 2))
    tmp_width=$(($width_zone - 2))
    while [ "$tmp" -lt "$tmp_poss" ] && [ "$tmp" -lt "$total_dir" ] ; do
	tmp_offset=$(($tmp + $offset_dir))
	[ "$position_dir" -eq "$tmp" ] && aff_on_entry_dir "${entry_dir[$tmp_offset]}" "$(($y_directory + $tmp))" 2 || aff_normal_entry_dir "${entry_dir[$tmp_offset]}" "$(($y_directory + $tmp))" 2
	tmp=$(($tmp + 1))
    done
    
    while [ "$tmp" -lt "$tmp_poss" ] ; do
	BUFF_AFF="${BUFF_AFF}`tput cup $(($tmp + $y_directory)) 2`$tmp_zone_space"
	tmp=$(($tmp + 1))
    done
}

aff_files()
{
    tmp=0
    tmp_poss=$(($height_zone - 2))
    tmp_width=$(($width_zone - 2))
    while [ "$tmp" -lt "$tmp_poss" ] && [ "$tmp" -lt "$total_files" ] ; do
	tmp_offset=$(($tmp + $offset_files))
	if [ "$position_files" -eq "$tmp" ] && [ $position -eq 1 ] ; then
	    aff_on_entry_files "${entry_files[$tmp_offset]}" $(($y_files + $tmp)) $x_files
	else
	    aff_normal_entry_files "${entry_files[$tmp_offset]}" $(($y_files + $tmp)) $x_files
	fi
	tmp=$(($tmp + 1))
    done
    
    while [ "$tmp" -lt "$tmp_poss" ] ; do
	BUFF_AFF="${BUFF_AFF}`tput cup $(($tmp + $y_files)) $x_files`$tmp_zone_space"
	tmp=$(($tmp + 1))
    done
}

load_inf_dir()
{
    # $1: repertoire

    cd "$1"
    DIR_CURRENT=$(pwd)
    total_dir=1
    total_files=0
    entry_dir[0]=".."
    for entry in * ; do
	[ -d "$entry" ] && entry_dir[$total_dir]="$entry" && total_dir=$(($total_dir + 1)) && continue
	[ -f "$entry" ] && entry_files[$total_files]="$entry" && total_files=$(($total_files + 1))
    done
}

check_if_files_on()
{
    # $1 -> nom du fichier

    tmp_pos=0
    while [ $tmp_pos -lt $TOTAL_FILES_SELECT ] ; do
	[ "${SELECTED_FILES[$tmp_pos]}" = "$1" ] && return 0 
	tmp_pos=$(($tmp_pos + 1))
    done
    return 1
}

aff_normal_entry_dir()
{
    BUFF_AFF="${BUFF_AFF}`tput cup $2 $3`"
    tmp_val="${#1}"
    tmp_width=$(($width_zone - 2))
    if [ "$tmp_val" -gt "$tmp_width" ] ; then
	tmp_val="${1:0:$tmp_width}"
	BUFF_AFF="${BUFF_AFF}$tmp_val"
    else
	BUFF_AFF="${BUFF_AFF}$1"
	while [ "$tmp_val" -lt "$tmp_width" ] ; do
	    BUFF_AFF="${BUFF_AFF} "
	    tmp_val=$(($tmp_val + 1))
	done
    fi
}

aff_on_entry_dir()
{
    BUFF_AFF="${BUFF_AFF}`tput setaf 7``tput setab 1``tput cup $2 $3`"
    tmp_val="${#1}"
    tmp_width=$(($width_zone - 2))
    if [ "$tmp_val" -gt "$tmp_width" ] ; then
	tmp_val="${1:0:$tmp_width}"
	BUFF_AFF="${BUFF_AFF}$tmp_val"
    else
	BUFF_AFF="${BUFF_AFF}$1"
	while [ "$tmp_val" -lt "$tmp_width" ] ; do
	    BUFF_AFF="${BUFF_AFF} "
	    tmp_val=$(($tmp_val + 1))
	done
    fi
    BUFF_AFF="${BUFF_AFF}`tput sgr0`"
}

aff_normal_entry_files()
{
    BUFF_AFF="${BUFF_AFF}`tput cup $2 $3`"
    tmp_val="${#1}"
    tmp_width=$(($width_zone - 2))
    tmp_stock=""
    if [ "$tmp_val" -gt "$tmp_width" ] ; then
	tmp_val="${1:0:$tmp_width}"
	tmp_stock="$tmp_val"
    else
	tmp_stock="$1"
	while [ "$tmp_val" -lt "$tmp_width" ] ; do
	    tmp_stock="$tmp_stock "
	    tmp_val=$(($tmp_val + 1))
	done
    fi
    if check_if_files_on "$DIR_CURRENT/$1" ; then
	BUFF_AFF="${BUFF_AFF}`tput setaf 2`$tmp_stock`tput sgr0`"
    else
	BUFF_AFF="${BUFF_AFF}$tmp_stock"
    fi
    unset tmp_stock
}

aff_on_entry_files()
{
    if [ -z "$4" ] ; then
	check_if_files_on "$DIR_CURRENT/$1" && foreground_color=2 || foreground_color=7
    fi
    BUFF_AFF="${BUFF_AFF}`tput setaf $foreground_color``tput setab 1``tput cup $2 $3`"
    tmp_val="${#1}"
    tmp_width=$(($width_zone - 2))
    if [ "$tmp_val" -gt "$tmp_width" ] ; then
	tmp_val="${1:0:$tmp_width}"
	BUFF_AFF="${BUFF_AFF}$tmp_val"
    else
	BUFF_AFF="${BUFF_AFF}$1"
	while [ "$tmp_val" -lt "$tmp_width" ] ; do
	    BUFF_AFF="${BUFF_AFF} "
	    tmp_val=$(($tmp_val + 1))
	done
    fi
    BUFF_AFF="${BUFF_AFF}`tput sgr0`"
    unset foreground_color
}

key_down_dir()
{
    BUFF_AFF=""
    tmp_offset=$(($offset_dir + $position_dir))
    [ "$((tmp_offset + 1))" -eq "$total_dir" ] && return 0

    tmp_poss=$(($height_zone - 2))
    if [ "$(($position_dir + 1))" -eq "$tmp_poss" ] ; then
	offset_dir=$(($offset_dir + 1))	
	aff_dirs
    else
	aff_normal_entry_dir "${entry_dir[$tmp_offset]}" "$(($y_directory + $position_dir))" 2
	aff_on_entry_dir "${entry_dir[$(($tmp_offset + 1))]}" "$(($y_directory + $position_dir + 1))" 2
	position_dir=$(($position_dir + 1))
    fi
    
    echo -n "$BUFF_AFF" >&2
    return 0
}

FileSelect_key_down_files()
{
    BUFF_AFF=""
    tmp_offset=$(($offset_files + $position_files))
    [ $(($tmp_offset + 1)) -eq $total_files ] && return 0

    tmp_poss=$(($height_zone - 2))
    if [ $(($position_files + 1)) -eq $tmp_poss ] ; then
	offset_files=$(($offset_files + 1))
	aff_files
    else
	aff_normal_entry_files "${entry_files[$tmp_offset]}" $(($y_files + $position_files)) $x_files
	aff_on_entry_files "${entry_files[$(($tmp_offset + 1))]}" $(($y_files + $position_files + 1)) $x_files
	position_files=$(($position_files + 1))
    fi
    
    echo -n "$BUFF_AFF" >&2
    return 0
}

FileSelect_key_up_files()
{
    BUFF_AFF=""
    tmp_offset=$(($offset_files + $position_files))
    [ $(($tmp_offset - 1)) -lt 0 ] && return 0

    tmp_poss=$(($height_zone - 2))
    if [ $(($position_files - 1)) -lt 0 ] ; then
	[ "$offset_files" -gt 0 ] && offset_files=$(($offset_files - 1))
	aff_files
    else
	aff_normal_entry_files "${entry_files[$tmp_offset]}" $(($y_files + $position_files)) $x_files
	aff_on_entry_files "${entry_files[$(($tmp_offset - 1))]}" $(($y_files + $position_files - 1)) $x_files
	position_files=$(($position_files - 1))
    fi

    echo -n "$BUFF_AFF" >&2
    return 0
}

key_up_dir()
{
    BUFF_AFF=""
    tmp_offset=$(($offset_dir + $position_dir))
    [ $(($tmp_offset - 1)) -lt 0 ] && return 0

    tmp_poss=$(($height_zone - 2))
    if [ $(($position_dir - 1)) -lt 0 ] ; then
	[ $offset_dir -gt 0 ] && offset_dir=$(($offset_dir - 1))
	aff_dirs
    else
	aff_normal_entry_dir "${entry_dir[$tmp_offset]}" $(($y_directory + $position_dir)) 2
	aff_on_entry_dir "${entry_dir[$(($tmp_offset - 1))]}" $(($y_directory + $position_dir - 1)) 2
	position_dir=$(($position_dir - 1))
    fi

    echo -n "$BUFF_AFF" >&2
    return 0
}

FileSelect_key_tabulation()
{
    BUFF_AFF=""
    if [ "$(($position + 1))" -eq 1 ] ; then
	tmp_offset=$(($offset_dir + $position_dir))
	aff_normal_entry_dir "${entry_dir[$tmp_offset]}" $(($y_directory + $position_dir)) 2
	tmp_offset=$(($offset_files + $position_files))
	aff_on_entry_files "${entry_files[$tmp_offset]}" $(($y_files + $position_files)) $x_files
	position=1
	echo -n "$BUFF_AFF" >&2
	return
    fi
    if [ "$(($position + 1))" -eq 2 ] ; then
	position=2
	tmp_offset=$(($offset_files + $position_files))
	aff_normal_entry_files "${entry_files[$tmp_offset]}" $(($y_files + $position_files)) $x_files
	FileSelect_aff_ok_button 1
	echo -n "$BUFF_AFF" >&2
	return
    fi
    if [ "$(($position + 1))" -eq 3 ] ; then
	position=3
	FileSelect_aff_ok_button 0
	FileSelect_aff_cancel_button 1
	return
    fi
    if [ "$(($position + 1))" -eq 4 ] ; then
	position=0
	tmp_offset=$(($offset_dir + $position_dir))
	aff_on_entry_dir "${entry_dir[$tmp_offset]}" $(($y_directory + $position_dir)) 2
	FileSelect_aff_cancel_button 0
	echo -n "$BUFF_AFF" >&2
	return
    fi
}

FileSelect_erase_elem()
{
    tmp=$1
    tmp_val=$(($TOTAL_FILES_SELECT - 1))
    while [ $tmp -lt $tmp_val ] ; do
	SELECTED_FILES[$tmp]="${SELECTED_FILES[$(($tmp + 1))]}"
	tmp=$(($tmp + 1))
    done
}

FileSelect_key_space()
{
    BUFF_AFF=""
    tmp_offset=$(($offset_files + $position_files))
    tmp_val="${DIR_CURRENT}/${entry_files[$tmp_offset]}"
    if check_if_files_on "$tmp_val" ; then
	foreground_color=7
	FileSelect_erase_elem $tmp_pos
	aff_on_entry_files "${entry_files[$tmp_offset]}" $(($y_files + $position_files)) $x_files TRUE
	TOTAL_FILES_SELECT=$(($TOTAL_FILES_SELECT - 1))
    else
	foreground_color=2
	SELECTED_FILES[$TOTAL_FILES_SELECT]="$tmp_val"
	aff_on_entry_files "${entry_files[$tmp_offset]}" $(($y_files + $position_files)) $x_files TRUE
	TOTAL_FILES_SELECT=$(($TOTAL_FILES_SELECT + 1))
    fi

    echo -n "$BUFF_AFF" >&2
}

FileSelect_key_page_up()
{
    BUFF_AFF=""
    if [ $position -eq 0 ] ; then
	tmp_offset=$(($offset_dir + $position_dir))
	[ $tmp_offset -eq 0 ] && return 0
	tmp_val=$(($position_dir - $height_zone))
	if [ $offset_dir -gt 0 ] && [ $tmp_val -lt "-3" ] ; then
	    offset_dir=$(($tmp_offset - $height_zone + 3))
	    [ $offset_dir -lt 0 ] && offset_dir=0
	    position_dir=0
	    aff_dirs
	else
	    aff_normal_entry_dir "${entry_dir[$tmp_offset]}" $(($y_directory + $position_dir)) 2
	    tmp_offset=$(($offset_dir + $position_dir - $height_zone + 3))
	    position_dir=0
	    [ $tmp_offset -lt 0 ] && tmp_offset=0
	    aff_on_entry_dir "${entry_dir[$tmp_offset]}" $y_directory 2
	fi 
    fi
    if [ $position -eq 1 ] ; then
	:
    fi

    echo -n "$BUFF_AFF" >&2
    return 0
}

FileSelect_key_page_down()
{
    BUFF_AFF=""
    if [ $position -eq 0 ] ; then
	tmp_offset=$(($offset_dir + $position_dir))
	[ $tmp_offset -eq $(($total_dir - 1)) ] && return 0
	tmp=$(($tmp_offset + $height_zone - 2))
	tmp_val=$(($height_zone - 2 - $position_dir))
	if [ $position_dir -gt 0 ] && [ $(($tmp_offset + $tmp_val)) -lt $total_dir ] ; then
	    if [ $(($tmp_offset + ($height_zone - 2))) -ge $total_dir ] ; then
		offset_dir=$(($total_dir - ($height_zone - 2)))
	    else
		offset_dir=$tmp_offset
	    fi
	    [ $offset_dir -ge $total_dir ] && offset_dir=$(($total_dir - 1)) 
	    position_dir=$(($height_zone - 3))
	    
	    aff_dirs
	else
	    aff_normal_entry_dir "${entry_dir[$tmp_offset]}" $(($y_directory + $position_dir)) 2
	    tmp_offset=$(($offset_dir + $position_dir + ($height_zone - 3)))
	    tmp_val=$(($height_zone - 3))
	    [ $tmp_val -ge $total_dir ] && position_dir=$(($total_dir - 1)) || position_dir=$tmp_val
	    [ $tmp_offset -ge $total_dir ] && tmp_offset=$(($total_dir - 1))
	    aff_on_entry_dir "${entry_dir[$tmp_offset]}" $(($y_directory + $position_dir)) 2
	fi 
    fi
    if [ $position -eq 1 ] ; then
	:
    fi

    echo -n "$BUFF_AFF" >&2
    return 0
}

FileSelect_change_directory()
{
    BUFF_AFF=""
    tmp_offset=$(($offset_dir + $position_dir))
    load_inf_dir "${entry_dir[$tmp_offset]}" 
    offset_dir=0
    offset_files=0
    position_dir=0
    position_files=0
    aff_dirs
    aff_files

    echo -n "$BUFF_AFF" >&2
}

FileSelect_aff_ok_button()
{
    [ "$1" -eq "1" ] && tput setaf 5 >&2
    tput cup $(($nb_lines - 3)) $(($nb_term_cols - 13 - 4 - 8)) >&2
    echo -n "--------" >&2
    tput cup $(($nb_lines - 2)) $(($nb_term_cols - 13 - 4 - 8)) >&2
    echo -n "|  OK  |" >&2
    tput cup $(($nb_lines - 1)) $(($nb_term_cols - 13 - 4 - 8)) >&2
    echo -n "--------" >&2
    [ "$1" -eq "1" ] && tput sgr0 >&2
}

FileSelect_aff_cancel_button()
{
    [ "$1" -eq "1" ] && tput setaf 5 >&2
    tput cup $(($nb_lines - 3)) $(($nb_term_cols - 13)) >&2
    echo -n "------------" >&2
    tput cup $(($nb_lines - 2)) $(($nb_term_cols - 13)) >&2
    echo -n "|  CANCEL  |" >&2
    tput cup $(($nb_lines - 1)) $(($nb_term_cols - 13)) >&2
    echo -n "------------" >&2
    [ "$1" -eq "1" ] && tput sgr0 >&2
}

FileSelect_clear_arrays()
{
    tmp=0
    while [ $tmp -lt $TOTAL_FILES_SELECT ] ; do
	unset SELECTED_FILES[$tmp]
	tmp=$(($tmp + 1))
    done
    tmp=0
    while [ $tmp -lt $total_dir ] ; do
	unset entry_dir[$total_dir]
	tmp=$(($tmp + 1))
    done
    tmp=0
    while [ $tmp -lt $total_files ] ; do
	unset entry_files[$total_files]
	tmp=$(($tmp + 1))
    done
}

files_selection()
{  
    tput clear >&2
    tput civis >&2
    stty -echo
    nb_term_cols=$(tput cols)
    nb_lines=$(tput lines)
    tput cup 0 $(($nb_term_cols / 2 - ${#1} / 2)) >&2
    tput bold >&2
    echo "$1" >&2
    tput sgr0 >&2
    echo "" >&2
    echo "" >&2
    echo "$2:" >&2
    IFS=$SAVE_IFS
    IFS=""
    DIR_CURRENT=""
    TOTAL_FILES_SELECT=0
    position=0

    offset_dir=0
    offset_files=0
    position_dir=0
    position_files=0
    aff_fondation
    load_inf_dir "/home/nyal"
    BUFF_AFF=""
    aff_dirs
    aff_files
    echo -n "$BUFF_AFF" >&2
    FileSelect_aff_ok_button 0
    FileSelect_aff_cancel_button 0
    
    while : ; do
	read -n 1 touche
	if [ "$touche" = "" ] ; then
	    read -n 1 touche
	    if [ "$touche" = "[" ] ; then
		read -n 1 touche
		if [ "$touche" = "B" ] ; then
		     [ $position -eq 0 ] && key_down_dir &&  continue
		     [ $position -eq 1 ] && FileSelect_key_down_files && continue
		fi
		if [ "$touche" = "A" ] ; then
		    [ $position -eq 0 ] && key_up_dir && continue
		    [ $position -eq 1 ] && FileSelect_key_up_files && continue
		fi
		if [ "$touche" = 5 ] ; then
		    read -n 1 touche
		    [ "$touche" = "~" ] && FileSelect_key_page_up || continue
		fi
		if [ "$touche" = 6 ] ; then
		    read -n 1 touche
		    [ "$touche" = "~" ] && FileSelect_key_page_down || continue
		fi
	    fi
	    continue
	fi
	[ "$touche" =  "	" ] && FileSelect_key_tabulation && continue
	[ "$touche" =  " " ] && [ $position -eq 1 ] && FileSelect_key_space && continue
	[ "$touche" =  " " ] && [ $position -eq 0 ] && FileSelect_change_directory && continue
	[ -z "$touche" ] && [ $position -eq 0 ] && FileSelect_change_directory && continue
	[ -z "$touche" ] && [ $position -gt 1 ] && break
    done

    stty echo
    tput sgr0 >&2
    tput cnorm >&2
    IFS=$SAVE_IFS

    tmp=0
    tmp_val=""
    while [ $tmp -lt $TOTAL_FILES_SELECT ] ; do
	[ -n "$tmp_val" ] && tmp_val="$tmp_val|${SELECTED_FILES[$tmp]}" || tmp_val="${SELECTED_FILES[$tmp]}"
	tmp=$(($tmp + 1))
    done
    echo "$tmp_val"

    FileSelect_clear_arrays
    unset DIR_CURRENT TOTAL_FILES_SELECT BUFF_AFF
    unset tmp_val tmp tmp_poss tmp_offset nb_term_cols nb_lines
    unset position_files position_dir y_directory y_files x_directory x_files offset_dir offset_files
    [ "$position" -eq "2" ] && return 1
    return 0  
}

#tutu=`file_selection "tutu" "Selection fichier"`

######################################################################
######################### FILES SELECTION ############################

# VERSION NOT USE
# VERSION WITHOUT TERMCAP

######################################################################

# ne gere pas les espaces dans les fichiers directement
# prendre le repertoire :)


fct_cmd_shell()
{
    # securite pour eviter les petits malins voulant executer 
    # du code indesirable :)

    cmd_wanted=`echo "$value" | awk -F "[;|&\\\`\$]" '{print $1; exit;}'`
    $cmd_wanted >&2
    return 0
}

fct_ok()
{
    if [ "$1" -eq "0" ] ; then
	cpt="0"
	value=""
	while [ "$cpt" -lt "$nb_elem_files" ] ; do
	    [ -n "$value" ] && value="$value|${tab[$cpt]}" || value="${tab[$cpt]}"
	    cpt=$(($cpt + 1))
	done
	echo "$value"
    fi
    RET_VALUE=$1
    return 0
}

fct_help()
{
    echo "Usage file selection:" >&2
    echo '	ls			: lister le repertoire
	cd			: bouger de repertoire
	put le_repertoire	: rajouter un fichier dans la liste
	rm [ numero | "all" ]	: enlever un fichier de la liste
	ok			: arrete la selection de fichier
	see			: voir la selection des fichiers
	help			: aide' >&2
}

fct_put()
{
    shift # enleve la commande ;)
    for file in $@ ; do
	if [ -f "$file" ] ; then
	    tab[$nb_elem_files]="`pwd`/$file"
	    nb_elem_files=$(($nb_elem_files + 1))
	fi
    done
}

fct_rm()
{
    shift
    for num in $@ ; do
	if [ "$num" = "all" ] ; then
	    nb_elem_files=0
	    break
	fi
	num=$(($num - 1))
	if [ "$num" -le "$nb_elem_files" ] && [ "$num" -gt "-1" ] ; then
	    cpt=$(($num + 1))
	    while [ "$cpt" -lt "$nb_elem_files" ] ; do
		tab[$(($cpt - 1))]="${tab[$cpt]}"
		cpt=$(($cpt + 1))
	    done
	    nb_elem_files=$(($nb_elem_files - 1))
	fi
    done
}

fct_see()
{
    cpt="0"
    echo "############### FILES SELECTION #############" >&2
    echo "" >&2
    while [ "$cpt" -lt "$nb_elem_files" ] ; do
	echo "$(($cpt + 1))	${tab[$cpt]}" >&2
	cpt=$(($cpt + 1))
    done
    echo "" >&2
    echo "#############################################" >&2
}

files_selection2()
{
    save_pwd="$PWD"
    nb_elem_files="0"
    
    while : ; do
	read -p "[33m<files selection ?help>[0m " -e value >&2
    
	fct=`echo "$value" | awk '$1 ~ /ls|cd|put|rm|help|ok|see|cancel/ {print $1; exit 0}'`
	([ "$fct" = "ls" ] || [ "$fct" = "cd" ]) && fct_cmd_shell && continue
	[ "$fct" = "ok" ] && fct_ok 0 && break
	[ "$fct" = "cancel" ] && fct_ok 1 && break
	[ "$fct" = "help" ] && fct_help
	[ "$fct" = "put" ] && fct_put $value
	[ "$fct" = "rm" ] && fct_rm $value
	[ "$fct" = "see" ] && fct_see
    done
    return $RET_VALUE
}

######################################################################
######################################################################
######################################################################
