#!/bin/sh

############################################################################
#                    CONFIGURATION                                         #
############################################################################

VERSION_PROG="v0.1g"

PROXY_ADDR="http://proxy-adress:port/"
PROXY_LOGIN="username"
PROXY_PASS="password"
FORCE_VALUE=""

PATH_TO_DECOMPRESS_DEF="/tmp/"
COPY_LIB_TO_DIR_DEF="/usr/local/lib/codecs/"
CUR_PWD="$PWD"

VIDEO_CODECS_PAGE="http://www1.mplayerhq.hu/homepage/design7/codecs.html"
VIDEO_CODECS_PAGE_SRC="http://www1.mplayerhq.hu/homepage/design7/"


xvid="http://downloads.xvid.org/downloads/xvidcore-1.1.0-beta2.tar.gz"

libao_DOWNLOAD="http://www.xiph.org/ao/src/libao-0.8.4.tar.gz"
libogg_DOWNLOAD="http://www.vorbis.com/files/1.0.1/unix/libogg-1.1.tar.gz"
libvorbis_DOWNLOAD="http://www.vorbis.com/files/1.0.1/unix/libvorbis-1.0.1.tar.gz"
libmad_DOWNLOAD="ftp://ftp.mars.org/pub/mpeg/libmad-0.15.1b.tar.gz"

libebml_DOWNLOAD="http://bunkus.org/videotools/mkvtoolnix/sources/libebml-0.6.4.tar.bz2"
libmatroska_DOWNLOAD="http://bunkus.org/videotools/mkvtoolnix/sources/libmatroska-0.6.3.tar.bz2"
patch_matroska="http://bunkus.org/videotools/mkvtoolnix/sources/mplayer1.0pre3-libmatroska063.diff"

x264="svn://svn.videolan.org/x264/trunk x264"

mplayerplugin="http://ovh.dl.sourceforge.net/sourceforge/mplayerplug-in/mplayerplug-in-2.80.tar.gz"
gecko_sdk="http://ftp.mozilla.org/pub/mozilla.org/mozilla/releases/mozilla1.6/gecko-sdk-i686-pc-linux-gnu-1.6.tar.gz"

pre7="http://www.mplayerhq.hu/MPlayer/releases/MPlayer-1.0pre7.tar.bz2"
pre6="http://www.mplayerhq.hu/MPlayer/releases/MPlayer-1.0pre6a.tar.bz2"
pre5="http://www.mplayerhq.hu/MPlayer/releases/MPlayer-1.0pre5try2.tar.bz2"
pre4="http://www1.mplayerhq.hu/MPlayer/releases/MPlayer-1.0pre4.tar.bz2"
pre3="http://www1.mplayerhq.hu/MPlayer/releases/MPlayer-1.0pre3.tar.bz2"
v92="http://www1.mplayerhq.hu/MPlayer/releases/MPlayer-0.92.tar.bz2"
cvsmplayer_directory="http://www1.mplayerhq.hu/MPlayer/cvs/"
cvsmplayer_name="MPlayer-current.tar.bz2"
cvsffmpeg="${cvsmplayer_directory}FFMpeg-current.tar.bz2"

western="http://www1.mplayerhq.hu/MPlayer/releases/fonts/font-arial-iso-8859-1.tar.bz2"
central="http://www1.mplayerhq.hu/MPlayer/releases/fonts/font-arial-iso-8859-2.tar.bz2"
central2="http://www1.mplayerhq.hu/MPlayer/releases/fonts/font-arial-cp1250.tar.bz2"
greek="http://www1.mplayerhq.hu/MPlayer/releases/fonts/font-arial-iso-8859-7.tar.bz2"
contribute="http://www1.mplayerhq.hu/MPlayer/contrib/fonts/"

ascii="http://ovh.dl.sourceforge.net/sourceforge/aa-project/aalib-1.4rc5.tar.gz"
ascii_color="http://sam.zoy.org/projects/libcaca/libcaca-0.9.tar.bz2"

live="http://www.live.com/liveMedia/public/live.2005.05.26a.tar.gz"

######################################################################
######  SYSTEME POUR LE DEPLACEMENT AU NIVEAU DES FENETRES      ######
######################################################################

TYPE_INSTALL=""
SECTION_GO=""
CHECK_PROXY="0"
ENDING_INST=""

######################################################################
####### ARGUMENT SUPPORT                                        ######
######################################################################

for arg in "$@"; do
    case $arg in
	--autaumat)
	    . autaumat.sh
	    exit 1
	    ;;
	-h|--help)
	    echo "Usage: mplayer_setup [-hV | -F graphics]
	  -V, --version               display version information
	  -h, --help                  display help
graphics: wish (tcl/tk), kdialog, zenity, Xdialog, dialog, console" >&2

	    exit 0
	    ;;
	-V|--version)
	    echo "mplayer_setup $VERSION_PROG (C) 2004 Nyal & Gouchi" >&2
	    exit 0
	    ;;
	-F)
	    shift
	    if [ "$1" = "console" ] ; then
		FORCE_VALUE=$1
	    elif [ "$1" = "zenity" ] || [ "$1" = "Xdialog" ] || [ "$1" = "dialog" ] || [ "$1" = "kdialog" ] || [ "$1" = "wish" ]; then
		FORCE_VALUE="$1"
		if ! which $FORCE_VALUE > /dev/null 2>&1 ; then
		    echo "Warning: Program $FORCE_VALUE isn't present in your system. You should check your PATH (env | grep PATH)" >&2
		    exit 1
		fi
	    fi
	    ;;
    esac
    shift
done

######################################################################

fx=""

CHOICE_VAR=""
if which zenity > /dev/null 2>&1 ; then
    if xdpyinfo > /dev/null 2>&1 ; then 
	CHOICE_VAR="zenity"
    fi
fi
if [ -z $CHOICE_VAR ] && which kdialog > /dev/null 2>&1 ; then
    if xdpyinfo > /dev/null 2>&1 ; then 
	CHOICE_VAR="kdialog"
    fi
fi
if [ -z $CHOICE_VAR ] && which wish > /dev/null 2>&1 ; then
    if xdpyinfo > /dev/null 2>&1 ; then 
	CHOICE_VAR="wish"
    fi
fi
if [ -z $CHOICE_VAR ] && which Xdialog > /dev/null 2>&1 ; then
    if xdpyinfo > /dev/null 2>&1 ; then 
	CHOICE_VAR="Xdialog"
    fi
fi
if [ -z $CHOICE_VAR ] && which dialog > /dev/null 2>&1 ; then
    CHOICE_VAR="dialog"
fi

if [ -z $CHOICE_VAR ] ; then
    CHOICE_VAR="console"
fi

if [ -z $CHOICE_VAR ] && [ -z $FORCE_VALUE ] ; then
    echo "ERROR: You must have at least one program of this list:
	- dialog
	- Xdialog
	- zenity
	- kdialog
You should read the README for more details" >&2
    exit 1
fi
. ${FORCE_VALUE:-${CHOICE_VAR}}_func.sh

############################################################################

#Check user
[ "`id -u`" -ne 0 ] && echo "[31mERROR[0m: The script must be running as root, type [31msu[0m" >&2 && exit 1 

#Welcome a Board
#Config Install
func_1()
{
    TYPE_OP="+"
    info_text "MPlayer Installation" "Welcome to MPlayer Installation"
    PATH_TO_DECOMPRESS=`entry_text "Config Install" "Choose the Path to decompress archives" "$PATH_TO_DECOMPRESS_DEF"`
    if [ "$?" -eq "1" ] ; then
	exit 0
	return 0
    fi
    
    if [ ! -d "$PATH_TO_DECOMPRESS" ] ; then
	if ! mkdir "$PATH_TO_DECOMPRESS" 2> /dev/null; then
	    PATH_TO_DECOMPRESS="/tmp/"
	fi
    fi
    PATH_TO_DECOMPRESS=$(echo "$PATH_TO_DECOMPRESS" | sed 's/\(.*\)\([^\/]\)$/\1\2\//')
    echo "PATH is $PATH_TO_DECOMPRESS"
    return 1
}

# Check Dependency
func_2()
{
    TYPE_OP="+"
    testing_com="wget awk bzip2 tar svn"
    value_to_pass=""
    for comm in $testing_com ; do
	if which $comm 2> /dev/null ; then
	    value_to_pass=$(echo "$value_to_pass
TRUE \"$comm available\"")
	else
	    value_to_pass=$(echo "$value_to_pass
FALSE \"$comm not available\"")
	fi
    done
    checklist_select "test" "Information" "$value_to_pass" > /dev/null
    if [ "$?" -eq "1" ] ; then
	TYPE_OP="-"
	return 1
    fi
    return 1
}

#Decompress
func_decompress()
{
    file_to_decompress="$1"
    command_to_do="$2"
    extension=`echo "$file_to_decompress" | awk -F\. 'BEGIN {ext=""} NF > 1 { for (i = NF; i > 1; i--) { if ($i !~ /(tar|gz|bz2|tgz|zip)/) break; if (ext) ext = $i "." ext; else ext=$i } } END {print ext}'`
    name_file=`echo "$file_to_decompress" | awk -F\/ '{ print $NF}'`
    echo -n "$name_file: " 
    case "$extension" in
	"tar.gz"|tgz)
	    tmp_values=$(tar -zxvf $file_to_decompress -C $PATH_TO_DECOMPRESS 2>&1)
	    VAL_RET="$?"
	    [ ! "$VAL_RET" -eq "0" ] && echo "Failed" && return $VAL_RET
	    repertoire_to_move=`echo "$tmp_values" | awk -F\/ 'NR == 1 { print $1; exit}'`
	    eval $command_to_do
	    VAL_RET="$?"
	    ;;
	"tar.bz2")
	    tmp_values=$(tar -jxvf $file_to_decompress -C $PATH_TO_DECOMPRESS 2>&1)
	    VAL_RET="$?"
	    [ ! "$VAL_RET" -eq "0" ] && echo "Failed" && return $VAL_RET
	    repertoire_to_move=`echo "$tmp_values" | awk -F\/ 'NR == 1 { print $1; exit}'`
	    eval $command_to_do
	    VAL_RET="$?"
	    ;;
	"zip")
	    # La fonction n'est pas bonne
	    tmp_values=$(unzip -o -d "$PATH_TO_DECOMPRESS" "$file_to_decompress" 2>&1)
	    VAL_RET="$?"
	    [ ! "$VAL_RET" -eq "0" ] && echo "Failed" && return $VAL_RET
	    repertoire_to_move=`echo "$tmp_values" | awk 'NR == 2 { print $2 ; exit}' | awk -F\/ '{print $(NF - 1)}'`
	    eval $command_to_do
	    VAL_RET="$?"
	    ;;
	*)
	    echo "$file_to_decompress: ERROR: Unknown extension $extension" >&2
	    return 1
	    ;;
    esac
    if [ "$3" = "TRUE" ] ; then
	if [ -n "$repertoire_to_move" ] ; then
	    rm -rf -- ${PATH_TO_DECOMPRESS}$repertoire_to_move
	fi
    fi
    [ "$VAL_RET" -eq "0" ] && echo "DONE" || echo "FAILED"
    return $VAL_RET
}

do_install()
{
    check_good="$2"
    command_to_do="$3"
    to_erase="$4"
    for FILE in `echo "$1" | awk -F\| '{ for (i = 1; i <= NF; i++) print $i }'` ; do
	for TMP in $check_good ; do
	    if [[ $FILE = */${TMP}* ]] ; then
		func_decompress "$FILE" "$command_to_do" "$to_erase"
		continue 2
	    fi
	done
	echo "#################### ERROR ##################"
    done
}

check_validity_cvs_mplayer()
{
    # $1 -> test if file exist
    # $2 -> file you want to recup

    if [ ! -s "$1" ] ; then
	wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" --output-document "${PATH_TO_DECOMPRESS}index.html" "$cvsmplayer_directory"
	val=$(cat "${PATH_TO_DECOMPRESS}index.html" | awk 'BEGIN {val_before=""; val_check="'$2'"} $0 ~ /.*<A HREF=".*(gz|bz2)"/ { match($0, /A HREF=".*">/); val_tar = substr($0, RSTART + 8, RLENGTH - 10); if (val_check == val_tar) { print val_before;exit}val_before=val_tar}')
	wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" --output-document "${PATH_TO_DECOMPRESS}$1" "${cvsmplayer_directory}$val"
	rm -f -- "${PATH_TO_DECOMPRESS}index.html"
	return 0
    fi
}

sort_video_codecs()
{
    ORDER_CHECK="essential* win32* rp* qt* *"
    val=""
    SAVE_IFS="$IFS"
    for CHECK in $ORDER_CHECK ; do
        IFS="|"
        for FILE in $1; do
            IFS="$SAVE_IFS"
            if [[ $FILE = */$CHECK* ]] ; then
                val="${val:+$val|}$FILE"
            fi
            IFS="|"
        done
        IFS="$SAVE_IFS"
    done
    echo "$val"
}

#Video Codecs video_install_Local()
func_50()
{
    COPY_LIB_TO_DIR=`entry_text "Config Install" "Choose the Path install Codecs" "$COPY_LIB_TO_DIR_DEF"`

    if [ "$?" -eq "1" ] ; then
	return 255
    fi
  
    if [ ! -d "$COPY_LIB_TO_DIR" ] ; then
	if ! mkdir "$COPY_LIB_TO_DIR" 2> /dev/null; then
	    COPY_LIB_TO_DIR="/usr/lib/win32"
	    mkdir "$COPY_LIB_TO_DIR"
	fi
    fi
    #echo "LIB to $COPY_LIB_TO_DIR" log message maybe
    info_text "Video Codecs Install" "We are going to install Video Codecs,\n Press CTRL to select many files"
    info_text "Video Codecs Install HOWTO" "
- Recommended: essential + win32 (not lite)
- Quicktime: qt5, qt6, and qtextra
- Real: rp8, rp9 (linux and win32)
- Misc (wmv9, 3ix,...): essential
"
    video=`files_selection "Video Codecs Install" "Select your Video Codecs"`
    if [ "$?" -eq "1" ] ; then
	return 255
    fi
    video=$(sort_video_codecs "$video")
    do_install "$video" "rp qt win32 essential" \
	'cp -f -- ${PATH_TO_DECOMPRESS}${repertoire_to_move}/* ${COPY_LIB_TO_DIR}/' TRUE 
    echo "[33mEND VIDEO CODECS INSTALLATION[0m"
    #Compatibily with old/others players
    ln -s $COPY_LIB_TO_DIR_DEF "/usr/lib/win32"
    cd $CUR_PWD
    return 0
}


#Audio Codecs audio_install_Local()
func_51()
{
    info_text "Audio Codecs Install" "We are going to install Audio Codecs,\nPress CTRL to select many files"
    info_text "Audio Codecs Install" "Try libao, libogg, libvorbis, libmad"
    audio=`files_selection "Audio Codecs Install" "Select your Audio Codecs"`

    if [ "$?" -eq "1" ] ; then
	return 255
    fi    
    do_install "$audio" "*ao *ogg *vorbis *mad" 'cd ${PATH_TO_DECOMPRESS}${repertoire_to_move} && ./configure && make && make install' TRUE
    
    echo "[33mEND AUDIO CODECS INSTALLATION[0m"
    cd $CUR_PWD
    return 0
}

#Matroska Check matroska_install_Local()
func_52()
{
    info_text "Matroska Install" "Matroska is the new container audio/video container\n *.mkv *.mka"
    id=`question_select "Matroska Install" "Do you want to install Matroska ? (included in CVS)"`
    if [ "$id" -eq 0 ] ; then
	echo ""
    else
	info_text "Try libebml"
	matroska=`files_selection "Libebml Install" "Select Libebml"`
	
	do_install "$matroska" "libebml" \
	    'cd ${PATH_TO_DECOMPRESS}${repertoire_to_move} && cd make/linux && make && make install' TRUE
    fi
    info_text "Matroska Install" "Try libmatroska"
    matroska=`files_selection "Matroska Install" "Select Libmatroska"`
    
    if [ "$?" -eq "1" ] ; then
	return 255
    fi    
    do_install "$matroska" "libmatroska" 'cd ${PATH_TO_DECOMPRESS}${repertoire_to_move} && cd make/linux && make && make install' FALSE
    echo "[33mEND MATROSKA INSTALLATION[0m"
    cd $CUR_PWD
    if [ "$?" -eq "1" ] ; then
	return 255
    fi    
}

install_mga()
{
    echo "Matrox you have"
    cd drivers
    size_ram=`lspci -v | awk 'BEGIN {matrox=0} matrox == 1 {print ; exit} -bash ~ /Matrox.*G400/ {matrox=1}' | sed 's/\([0-9]\).*/\1/'`
    make
    mknod /dev/mga_vid c 178 0
    insmod mga_vid.o mga_ram_size=$size_ram

    # Slackware type
    if [ -f "/etc/rc.d/rc.modules" ] ; then
	echo "Slackware type"
	echo "insmod /lib/modules/`uname -r`/mga_vid.o" >> /etc/rc.d/rc.modules
    else
	echo "Other linux"
    #Debian User alias char-major-178 mga_vid >> /etc/modutils/mga 
    #and update-modules #cat /proc/version
	echo "alias char-major-178 mga_vid" >> /etc/modules.conf 
    fi
    cp mga_vid.o /lib/modules/`uname -r`
    depmod -a
}

install_ati()
{
    echo "ATI you have"
    cd drivers/radeon
    make && make install && make nodes
    ls
}

install_3dfx()
{
    echo "3Dfx you have"
    cd drivers
    make && make install 
    $fx="--enable-3dfx --enable-tdfxfb"
}

#MPlayer Configure
mplayer_configure()
{
    ./configure $fx $largefiles $gui $cpu --with-codecsdir=$COPY_LIB_TO_DIR_DEF && make && make install
}

#MPlayer Install mplayer_install_Local()
func_53()
{
    info_text "MPlayer Install" "Try MPlayer"
    mplayer_choix=`files_selection "MPlayer Install" "Select MPlayer Package"`

    if [ "$?" -eq "1" ] ; then
	return 255
    fi    
    do_install "$mplayer_choix" "MPlayer" \
	'cd ${PATH_TO_DECOMPRESS}${repertoire_to_move}' FALSE
    #Check Graphic Card
    info_text "Checking Graphic Card you have ..."
    lspci | grep Matrox > /dev/null 2>&1
    if [ "$?" == 0 ] ; then
	install_mga
    fi
    lspci | grep ATI > /dev/null 2>&1
    if [ "$?" == 0 ] ; then
	install_ati
    fi
    lspci | grep 3Dfx > /dev/null 2>&1
    if [ "$?" == 0 ] ; then
	install_3dfx
    fi
    mplayer_configure
    echo "[33mEND MPLAYER INSTALLATION[0m"
    cd $CUR_PWD
    return 0
}

#font_install_Local()
func_54()
{
    
#Check PATH
    if [ ! -d ~/.mplayer ] ; then
	mkdir ~/.mplayer
    fi
    if [ ! -d ~/.mplayer/font ] ; then
	mkdir ~/.mplayer/font
    fi
  #Font Installation
    info_text "Font Install" "We are going to install Font"
    font=`files_selection "Font install" "Select your Font Size"`
    if [ "$?" -eq "1" ] ; then
	return 255
    fi    
    
    CHECK_GOOD="font"
    
    do_install "$font" "font" \
	'cd ${PATH_TO_DECOMPRESS}${repertoire_to_move}' FALSE
 
    name_file=`echo "$font" | awk -F\- '{ print $1 "-" $2 }'`
    size=`radiolist_select "Local Installation" "Choose Size of Font" "FALSE 14
FALSE 18
FALSE 24
FALSE 28"`

    if [ "$?" -eq "1" ] ; then
	return 255
    fi    
    cp -R font-arial-${size}*/* ~/.mplayer/font
    cp -R font-arial-${size}*/* /usr/local/share/mplayer/font/
    chmod 444 /usr/local/share/mplayer/font/*
    echo "[33mEND FONT INSTALLATION[0m"
    cd $CUR_PWD
    info_text "Remenber" "(remenber to copy font for all user) in ~/.mplayer/font"
    return 0
}

#### Misc #####
func_55()
{
    return 0
}

# Install
func_4()
{
    #echo "Installation Choice"
    
    TYPE_OP="+"
    SECTION_GO=""
    if [ "$TYPE_INSTALL" = "Network" ] && [ "$CHECK_PROXY" -eq "1" ] ; then
	support_proxy
    fi
    CHECK_PROXY="0"
    type=`checklist_select "$TYPE_INSTALL Installation" "Choose type of installation" 'FALSE "Video Codecs"
FALSE "Audio Codecs"
FALSE Matroska
FALSE Misc
FALSE MPlayer
FALSE Font'`

    if [ "$?" -eq "1" ] ; then
	TYPE_OP="-"
	return 1
    fi    
    if [ "$TYPE_INSTALL" = "Local" ] ; then
	COEFF_MULT='1'
    else
	COEFF_MULT='2'
    fi
    SAVE_IFS="$IFS"
    IFS="|"
    for FILE in $type ; do
	IFS="$SAVE_IFS"
	case "$FILE" in
	    "Video Codecs")
		SECTION_GO="$SECTION_GO $(($COEFF_MULT * 50))"
	    ;;
	    "Audio Codecs")
		SECTION_GO="$SECTION_GO $(($COEFF_MULT * 50 + 1))"
	    ;;
	    "Matroska")
		SECTION_GO="$SECTION_GO $(($COEFF_MULT * 50 + 2))"
	    ;;
	    "MPlayer")
		SECTION_GO="$SECTION_GO $(($COEFF_MULT * 50 + 3))"
	    ;;
	    "Font")
		SECTION_GO="$SECTION_GO $(($COEFF_MULT * 50 + 4))"
	    ;;
	    "Misc")
		SECTION_GO="$SECTION_GO $(($COEFF_MULT * 50 + 5))"
	    ;;
	esac
	IFS="|"
    done
    if [ -z "$SECTION_GO" ] ; then
	ENDING_INST="end"
    fi
    IFS="$SAVE_IFS"
    return 0
}

####################################################################
#                    Network Installation                          #
####################################################################

wget_page()
{
    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" --output-document 'index.html' "$1"
}

get_addr_from_file()
{
    cat -- "$1" | awk 'BEGIN {comment=0} $0 ~ /-->$/ {comment=0; next} comment == 1 {next} $0 ~ /<!--/ { comment=1; next} $0 ~ /.*<td><a href=".*(gz|bz2|zip)"/ { match($0, /".*">/); val_tar = substr($0, RSTART + 1, RLENGTH - 3); match($0, /">.*<\/a>/); val_aff=substr($0, RSTART + 2, RLENGTH - 6); print val_tar "|" val_aff}' | sed "s/\"//g"
}

support_proxy()
{
    id=`question_select "Proxy Support" "Did you use a Proxy ?"`
    if [ $id -eq "0" ] ; then
	PROXY_ADDR=`entry_text "Proxy Authentification" "Please enter proxy adress" "$PROXY_ADDR"`
	PROXY_LOGIN=`entry_text "Proxy Authentification" "Please enter your login" "$LOGNAME"`
	PROXY_PASS=`entry_hide "Proxy Authentification" "Please enter your password"`
	PROXY_LOGIN_USE="$PROXY_LOGIN"
	PROXY_PASS_USE="$PROXY_PASS"
	export http_proxy="$PROXY_ADDR"
	export ftp_proxy="$PROXY_ADDR"
	return
    fi
    PROXY_LOGIN_USE=""
    PROXY_PASS_USE=""
    unset http_proxy
    unset ftp_proxy
}

#video_install_Network()
func_100()
{
    COPY_LIB_TO_DIR=`entry_text "Config Install" "Choose the Path install Codecs" "$COPY_LIB_TO_DIR_DEF"`
    
    if [ "$?" -eq "1" ] ; then
	return 255
    fi    
    if [ ! -d "$COPY_LIB_TO_DIR" ] ; then
	if ! mkdir "$COPY_LIB_TO_DIR" 2> /dev/null; then
	    COPY_LIB_TO_DIR="/usr/lib/win32"
	    mkdir "$COPY_LIB_TO_DIR"
	fi
    fi
    #echo "LIB to $COPY_LIB_TO_DIR" maybe log message

    cd "${PATH_TO_DECOMPRESS}"
    wget_page "$VIDEO_CODECS_PAGE"
    values_page=$(get_addr_from_file "${PATH_TO_DECOMPRESS}index.html")
    values_select=$(echo "$values_page" | awk -F\| '{ print "FALSE \"" $2 "\""}')
    info_text "Video Codecs Install HOWTO" "
- Recommended: all  codecs for Linux x86
"
    selection=`checklist_select "Video Codecs Install from Network" "Select your Video Codecs" "$values_select"`
    if [ "$?" -eq "1" ] ; then
	return 255
    fi
    SAVE_IFS="$IFS"
    IFS="|"
    for FILE in $selection ; do
        cd "${PATH_TO_DECOMPRESS}"
        IFS="$SAVE_IFS"
        FILE_GOOD=`echo "$values_page" | grep "|$FILE\$" | awk -F\| '{print $1}'`
	FILE_NAME=$(echo "$FILE_GOOD" | awk -F\/ '{ print $NF }')
        wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" --output-document "$FILE_NAME" "$VIDEO_CODECS_PAGE_SRC$FILE_GOOD"
        do_install "${PATH_TO_DECOMPRESS}$FILE_NAME" "rp qt win32 windows essential all" 'cp -f -- ${PATH_TO_DECOMPRESS}${repertoire_to_move}/* ${COPY_LIB_TO_DIR}/' TRUE
        IFS="|"
    done
    IFS="$SAVE_IFS"
    cd "$CUR_PWD"
    #Compatibily with old/others players
    ln -s $COPY_LIB_TO_DIR_DEF "/usr/lib/win32"
    echo "[33mEND VIDEO CODECS INSTALLATION[0m"
    return 0
}

#audio_install_Network()
func_101()
{
    info_text "Audio Codecs Install" "We are going to install Audio Codecs"
    selection=`checklist_select "Audio Codecs install from Network" "Select your Audio Codecs" 'TRUE libogg/vorbis
TRUE libmad'`
    if [ "$?" -eq "1" ] ; then
	return 255
    fi    
    if [[ $selection = *ogg* ]] ; then
	selection="libao|`echo \"$selection\" | awk -F\/ '{ print $1 \"|lib\" $2}'`"
    fi
    for FILE in `echo "$selection" | awk -F\| '{ for (i = 1; i <= NF; i++) print $i }'` ; do
	cd "${PATH_TO_DECOMPRESS}"
	eval wget -r --proxy-user=\"\$PROXY_LOGIN_USE\" --proxy-passwd=\"\$PROXY_PASS_USE\" --output-document \"\${FILE}.tar.gz\" \"\$${FILE}_DOWNLOAD\"
	do_install "${PATH_TO_DECOMPRESS}${FILE}.tar.gz"  "*ao *ogg *vorbis *mad" 'cd ${PATH_TO_DECOMPRESS}${repertoire_to_move} && ./configure && make && make install' TRUE
    done
    echo "[33mEND AUDIO CODECS INSTALLATION[0m"
    cd "$CUR_PWD"
    return 0
}

#matroska_install_Network()
func_102()
{
    info_text "Matroska Install" "Matroska Install"
    selection="libebml|libmatroska"
    for FILE in `echo "$selection" | awk -F\| '{ for (i = 1; i <= NF; i++) print $i }'` ; do
	cd "${PATH_TO_DECOMPRESS}"
	eval wget -r --proxy-user=\"\$PROXY_LOGIN_USE\" --proxy-passwd=\"\$PROXY_PASS_USE\" --output-document \"\${FILE}.tar.bz2\" \"\$${FILE}_DOWNLOAD\"
	do_install "${PATH_TO_DECOMPRESS}${FILE}.tar.bz2" "*ebml *matroska" 'cd ${PATH_TO_DECOMPRESS}${repertoire_to_move} && cd make/linux && make && make install' TRUE
    done
    echo "[33mEND MATROSKA INSTALLATION[0m"
    cd "$CUR_PWD"
    return 0
}

#mplayer_install_Network()
func_103()
{
    echo "MPlayer Network Install"
    
    outputpre7="pre7.tar.bz2"
    outputpre6="pre6.tar.bz2"
    outputpre5="pre5.tar.bz2"
    outputpre4="pre4.tar.bz2"
    outputpre3="pre3.tar.bz2"
    outputv92="v92.tar.bz2"
    outputcvsmplayer="cvsmplayer.tar.bz2"
    outputcvsffmpeg="cvsffmpeg.tar.bz2"
    
    version=`radiolist_select "Network Installation" "Choose your Version" 'FALSE "MPlayer v1.0pre7" 
FALSE "MPlayer v1.0pre6" 
FALSE "MPlayer v1.0pre5" 
FALSE "MPlayer v1.0pre4"
FALSE "MPlayer v1.0pre3" 
FALSE "MPlayer v0.92" 
FALSE "MPlayer CVS"'`
    
    if [ "$?" -eq "1" ] ; then
	return 255
    fi    
    cd "${PATH_TO_DECOMPRESS}"
    echo "Version $version"
    case "$version" in

	"MPlayer v1.0pre7")
	    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" "$pre7"  --output-document "$outputpre7"
	    func_decompress "$outputpre7" 'cd ${repertoire_to_move}' FALSE 
	    mplayer_configure
	    ;;
	"MPlayer v1.0pre6")
	    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" "$pre6"  --output-document "$outputpre6"
	    func_decompress "$outputpre6" 'cd ${repertoire_to_move}' FALSE 
	    mplayer_configure
	    ;;

	"MPlayer v1.0pre5")
	    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" "$pre5"  --output-document "$outputpre5"
	    func_decompress "$outputpre5" 'cd ${repertoire_to_move}' FALSE 
	    mplayer_configure
	    ;;
	"MPlayer v1.0pre4")
	    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" "$pre4"  --output-document "$outputpre4"
	    func_decompress "$outputpre4" 'cd ${repertoire_to_move}' FALSE
	    mplayer_configure
	    ;;
	"MPlayer v1.0pre3")
	    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" "$pre3"  --output-document "$outputpre3"
	    func_decompress "$outputpre3" 'cd ${repertoire_to_move}' FALSE 
 
	    #PATCH matroska mplayer
	    cd libmpdemux
            wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" "$patch_matroska" --output-document "$output_patch"
            patch -p0 < $output_patch
            cd ..
            echo "PATCH Successfully added"
	    mplayer_configure
	    ;;
	"MPlayer v0.92")
	    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" "$v92" --output-document "$outputv92"
	    func_decompress "$outputv92" 'cd ${repertoire_to_move}' FALSE 
	    mplayer_configure
	    ;;
	"MPlayer CVS")
	    wget -r --proxy-user="$PROXY_LOGIN" --proxy-passwd="$PROXY_PASS" "$${cvsmplayer_directory}$cvsmplayer_name" --output-document "$outputcvsmplayer"
	    check_validity_cvs_mplayer "$outputcvsmplayer" "$cvsmplayer_name"
	    func_decompress "$outputcvsmplayer" 'cd ${repertoire_to_move}' FALSE 
	    FUNC_DECOMP_GOOD="$?"
	    temp="$repertoire_to_move"
	    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" "$cvsffmpeg" --output-document "$outputcvsffmpeg"
	    if [ -s "$cvsffmpeg" ] ; then
		func_decompress "$outputcvsffmpeg" 'cd ${repertoire_to_move}' FALSE 
		cp -R libav* "../$temp"
		cd "../$temp"
	    fi
	    if [ "$FUNC_DECOMP_GOOD" -eq "0" ] ; then
	       mplayer_configure
	    fi
	    ;;
    esac
}

#Font Installation font_install_Network()
func_104()
{

    info_text "Font Install" "We are going to install Font"
    
    outputwestern="western.tar.bz2"
    outputcentral="central.tar.bz2"
    outputcentral2="central2.tar.bz2"
    outputgreek="greek.tar.bz2"
    
#Check PATH
    if [ ! -d ~/.mplayer ] ; then
	mkdir ~/.mplayer
    fi
    if [ ! -d ~/.mplayer/font ] ; then
	mkdir ~/.mplayer/font
    fi
    
    size=`radiolist_select "$TYPE_INSTALL Installation" "Choose Size of Font" "FALSE 14
FALSE 18
FALSE 24
FALSE 28"`
    
    if [ "$?" -eq "1" ] ; then
	return 255
    fi    
    font=`radiolist_select "$TYPE_INSTALL Installation" "Choose your Type Font" 'FALSE "Arial - Western (ISO 8859-1) (4 sizes)" 
FALSE "Arial - Central European (ISO 8859-2) (4 sizes)" 
FALSE "Arial - Central European (CP1250) (4 sizes)"
FALSE "Arial - Greek (ISO 8859-7) (4 sizes)"
FALSE "Contributed fonts (unsupported)"'`
    
    if [ "$?" -eq "1" ] ; then
	return 255
    fi    
    cd "${PATH_TO_DECOMPRESS}"
    case "$font" in
	"Arial - Western (ISO 8859-1) (4 sizes)")
	    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" $western  --output-document "$outputwestern"
	    func_decompress "$outputwestern" 'cd ${repertoire_to_move}' FALSE 
	    ;;
	"Arial - Central European (ISO 8859-2) (4 sizes)")
	    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" $central --output-document "$outputcentral"
	    func_decompress "$outputcentral" 'cd ${repertoire_to_move}' FALSE 
	    ;;
	"Arial - Central European (CP1250) (4 sizes)")
	    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" $central2 --output-document "$outputcentral2"
	    func_decompress "$outputcentral2" 'cd ${repertoire_to_move}' FALSE 
	    ;;
"Arial - Greek (ISO 8859-7) (4 sizes)")
	    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" $greek --output-document "$outputgreek"
	    func_decompress "$outputgreek" 'cd ${repertoire_to_move}' FALSE 
	    ;;
"Contributed fonts (unsupported)")
	    info_text "Contributed fonts" "Try at $contribute"
	    info_text "Remenber" "remenber to copy font in /usr/local/share/mplayer/font/"
	    cd $CUR_PWD
	    return 0
	    ;;
    esac
    
    cp -R font-arial-${size}*/* ~/.mplayer/font    
    cp -R font-arial-${size}*/* /usr/local/share/mplayer/font/
    chmod 444 /usr/local/share/mplayer/font/*
#info_text "Install Font User Systemp" "Remember to  cp font-arial-18-iso-8859-2/* ~/.mplayer/font/ for all User"
    echo "[33mEND FONT INSTALLATION[0m"
    cd $CUR_PWD 
    return 0
}

#### Misc for network #####

do_ascii()
{
    echo "Ascii Video Output"
    outputascii="ascii.tar.gz"
    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" "$ascii" --output-document "$outputascii"
    func_decompress "$outputascii" 'cd ${repertoire_to_move}' FALSE 
    ./configure && make && make install

}

do_ascii_color()
{
    echo "Ascii Color Video Output"
    outputasciicolor="asciicolor.tar.bz2"
    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" "$ascii_color" --output-document "$outputasciicolor"
    func_decompress "$outputasciicolor" 'cd ${repertoire_to_move}' FALSE 
    #check --disable-imlib2 --disable-doxygen if failed
    ./configure && make && make install
}

do_live()
{
echo "Live.com support"
    outputlive="live.tar.gz"
    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" "$live" --output-document "$outputlive"
    func_decompress "$outputlive" 'cd ${repertoire_to_move}' FALSE 
    ./genMakefiles `uname | tr '[:upper:]' '[:lower:]'`; make ; mv ../live /usr/lib/local
    live="--enable-live"
}

set_largefiles()
{
echo "Large Files"
largefiles="--enable-largefiles"
}
set_gui()
{
echo  "Enable Gui"
gui="--enable-gui"
}

do_xvid()
{
    echo "Xvid Support"
    outputxvid="xvid.tar.gz"
    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" "$xvid" --output-document "$outputxvid"
    func_decompress "$outputxvid" 'cd ${repertoire_to_move}' FALSE 
    cd build/generic
    ./configure && make && make install
}

do_cpu()
{
echo "Enable Runtime CPU Detection"
cpu="--enable-runtime-cpudetection"
}

do_x264()
{
    info_text "x264 Support" "You must have subversion to install x264 (svn)";
    echo "x264 Support"
    cd $PATH_TO_DECOMPRESS_DEF
    svn co $x264
    cd x264
    ./configure && make && make install
}

do_mplayerplugin()
{
    info_text "MPlayerplug-in Support" "You have to install mozilla-dev package";
    echo "MPlayerplug-in Support"
    cd $PATH_TO_DECOMPRESS_DEF
    outputgecko="gecko-sdk.tar.gz"
    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" "$gecko_sdk" --output-document "$outputgecko"
    func_decompress "$outputgecko" 'cd ${repertoire_to_move}' FALSE 
    cd ..;cp -R gecko-sdk /usr/local/lib
    outputmplayerplugin="mplayerplugin.tar.gz"
    wget -r --proxy-user="$PROXY_LOGIN_USE" --proxy-passwd="$PROXY_PASS_USE" "$mplayerplugin" --output-document "$outputmplayerplugin"
    func_decompress "$outputmplayerplugin" 'cd ${repertoire_to_move}' FALSE 
    ./configure --with-gecko-sdk="/usr/local/lib/gecko-sdk" && make && make install
    #Mozilla 
    echo "[33mInstall MPlayerplugin for Mozilla[0m"
    cp mplayerplug-in.so /usr/lib/mozilla/plugins
    cp mplayerplug-in.xpt /usr/lib/mozilla/components
    #Mozilla Firefox
    echo "[33mInstall MPlayerplugin for Mozilla Firefox[0m"
    cp mplayerplug-in.so /usr/lib/mozilla-firefox/plugins
    cp mplayerplug-in.xpt /usr/lib/mozilla-firefox/components
}



func_105()
{

     cd "${PATH_TO_DECOMPRESS}"
     misc=`checklist_select "Network Installation" "Choose your Misc" 'FALSE "MPlayerplug-in Support" 
FALSE "Live.com Support" 
FALSE "Xvid Support" 
FALSE "Ascii Video Output" 
FALSE "Ascii Color Video Output" 
FALSE "Runtime CPU Detection" 
FALSE "x264 Support" 
FALSE "Enable Support for Files > 2 GBytes"'`

    if [ "$?" -eq "1" ] ; then
	return 255
    fi    
    
    SAVE_IFS="$IFS"
    IFS="|"
    for FILE in $misc ; do
    IFS="$SAVE_IFS"
    case "$FILE" in
"Xvid Support")
    do_xvid
    ;;
"Ascii Video Output")
    do_ascii
    ;;
"Ascii Color Video Output")
    do_ascii_color
    ;;
"Enable Support for Files > 2 GBytes")
    set_largefiles
    ;;
"Enable Gui")
    set_gui
    ;;
"Live.com Support")
    do_live
    ;;
"Runtime CPU Detection")
    do_cpu
    ;;
"x264 Support")
    do_x264
    ;;
"MPlayerplug-in Support")
    do_mplayerplugin
    ;;
    esac
   IFS="|"
   done
   IFS="$SAVE_IFS"
   return 0
}

####################################################################
####################################################################
####################################################################

# Choice of installation

func_3() 
{
    TYPE_OP="+"
    type=`radiolist_select "MPlayer Installation" "Choose Type of installation" 'TRUE "Local Installation"
FALSE "Network Installation"'`
    
    if [ "$?" -eq "1" ] ; then
	TYPE_OP="-"
	return 1
    fi
    case "$type" in
"Local Installation")
	    TYPE_INSTALL="Local"
	    return 1
	    ;;
"Network Installation")
	    TYPE_INSTALL="Network"
	    CHECK_PROXY="1"
	    return 1
	    ;;
	*)
	    info_text "Choose type of installation"
	    return 0
	    ;;
    esac
    return 0
}

end_install()
{
    info_text "End of Installation" "Enjoy :)" 
    exit 0
}

VAL_FOR_FUNC=1
while : ; do
    eval func_${VAL_FOR_FUNC}
    VAL_FOR_FUNC=$(($VAL_FOR_FUNC $TYPE_OP $?))
    if [ -n "$SECTION_GO" ] ; then
	for SECTION in $SECTION_GO ; do
	    VAL_FOR_FUNC="$SECTION"
	    eval func_${VAL_FOR_FUNC}
	    if [ "$?" -eq 255 ] ; then
		VAL_FOR_FUNC="4"
		SECTION_GO=""
		continue 2
	    fi
	done
	ENDING_INST="end"
    fi
    if [ "$ENDING_INST" = "end" ] ; then
	end_install
    fi
done
