#!/bin/bash

files_selection()
{
    # $1 -> title
    # $2 -> text

    zenity --file-selection  --multiple --title="$2"
    return $?
}

entry_hide()
{
    # $1 -> title
    # $2 -> text
    
    zenity --entry --hide-text --text="$2" --title="$1"
    return $?
}

entry_text()
{
    # $1 -> title
    # $2 -> text
    # $3 -> default entry
    
    zenity --entry --text="$2" --entry-text="$3" --title="$1"
    return $?
}

info_text()
{
    # $1 -> title
    # $2 -> text

    zenity --info --text="$2" --title="$1" 
    return $?
}

radiolist_select()
{
    # $1 title
    # $2 text
    # $3 values. Must recreate data
    # $4 force height
    # $5 force width

    eval zenity --title=\"$1\" --width=400 --height=400 --list --radiolist --column=Selection --column=\"$2\" $3
    return $?
}

checklist_select()
{
    # $1 title
    # $2 text
    # $3 values

    eval zenity --width=300 --height=300 --title=\"$1\" --list --checklist --column=Selection --column=\"$2\" $3
    return $?
}

question_select()
{
    # $1 title
    # $2 value

    zenity --title="$1" --question --text="$2"
    DIALOG_RET=$?
    echo $DIALOG_RET
    return $DIALOG_RET
}
